#ifndef HPCXX_DUROC_LIB_H
#define HPCXX_DUROC_LIB_H

#define GS_GRAM_CLIENT_INIT_FAILED 1
#define GS_NEXUS_INIT_FAILED 2
#define GS_ALLOW_ATTACH_FAILED 3
#define GS_MDS_SEARCH_FAILED 4

#define NEXUS_INIT_FAILED 1
#define MYJOB_INIT_FAILED 2
#define CONNECT_FAILED 3
#define SEND_FAILED 4

#define GS_MODE_NORMAL 0
#define GS_MODE_CLEANUP 1

#define GLOBUS_MONITOR_SUCCESS 0
#define GLOBUS_MONITOR_DONE 1

#include<globus_nexus.h>

#ifdef __cplusplus
extern "C" {
#endif

  typedef struct _globus_monitor_t globus_monitor_t;

  struct _globus_monitor_t {
    globus_mutex_t mutex;
    globus_cond_t cond;
    globus_bool_t success;
    globus_bool_t done;
  };

  typedef struct sp_list_ sp_list;
  
  struct sp_list_ {
    globus_monitor_t *Monitor;
    globus_nexus_startpoint_t *remoteSP;
    int procNum;
	int deleteFlag;
    char *job_contact;
    char *callback_contact;
    sp_list *next;
  };

  int getContactString( char *hostname, char *contactString);
  
  int duroc_init(int argc, char **argv);
  int duroc_rendezvous(globus_nexus_startpoint_t localSP,
			     globus_nexus_startpoint_t **remoteSP_ar);
  int getMyID(void);
  int getNumProcs(void);
  int duroc_cleanup(void);
  int duroc_abort(void);

  int gs_init(void);
  int gs_connect(char *hostname);
  globus_nexus_startpoint_t *gs_create_process(char *name,char *host,char *path);
  int gs_disconnect(sp_list *link, int mode);
  void gs_cleanup(void);

  int gc_init(char **argv);
  int gc_connect(globus_nexus_endpoint_t *ep);
  void gc_cleanup(void);
  void gc_abort(void);

  void globus_monitor_init(globus_monitor_t *Monitor);
  void globus_monitor_reset(globus_monitor_t *Monitor);
  int globus_monitor_wait(globus_monitor_t *Monitor);
  void globus_monitor_release(globus_monitor_t *Monitor, int trigger); 
  void globus_monitor_destroy(globus_monitor_t *Monitor);

  void globus_endpoint_setup(globus_nexus_endpoint_t *ep,globus_nexus_handler_t *handler_table, int size);
  
#ifdef __cplusplus
}
#endif


#endif
