// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: HPCxx_CondImpl.h,v 1.3 1999/01/29 23:47:21 rasmussn Exp $

#ifndef __HPCXX_CONDIMPL_H_
#define __HPCXX_CONDIMPL_H_

#include <Smarts.h>
#include <Cond.h>
#include <HPCxx_MutexImpl.h>

class HPCxx_CondImpl {
private:
  Smarts::Cond cond_;

public:
  HPCxx_CondImpl(void);
  virtual ~HPCxx_CondImpl(void);

  virtual int wait(HPCxx_MutexImpl& mutex);
  virtual int signal(void);
  virtual int broadcast(void);

public:
  HPCxx_CondImpl(const HPCxx_CondImpl& cond);
  HPCxx_CondImpl& operator=(const HPCxx_CondImpl& cond);

};

#endif

