// -*-c++-*-

#ifndef __HPCXX_ARRAYS_H_
#define __HPCXX_ARRAYS_H_

#include <iostream.h>
#include <HPCxx_Buffer.h>
#include "Constants.h"
#include <assert.h>
#include "HPCxx_String.h"

template <class T, int n> 
class HPCxx_Array { 

private:
  int len;
  T value[n];
  int rel; 
  int type;  // indicates data type of  T
  HPCxx_String FQNofObject; // required for String[] and Obj[]
  // 10 boolean array
  // 11 byte array
  // 12 short array
  // 13 int array
  // 14 long array
  // 15 float array
  // 16 double array
  // 17 char array
  // 18 array of references (HPCxx_String, TestObj, ...)

public:
  HPCxx_Array() : rel(0), type(0), FQNofObject(NULL) { len = n;}
  HPCxx_Array(int t) : rel(1), type(t), FQNofObject(""){ len = n;}
  HPCxx_Array(T *v, int l, int r = 1, int tpe = 10 ) : type(tpe), rel(r) {
   len = n;
   for(int i = 0; (i < len) && (i < l); i++) value[i] = r[i]; 
} 

  HPCxx_Array(HPCxx_Array<T, n> &source);
  
  HPCxx_Array<T,n>& operator=(HPCxx_Array<T,n> &source);

  void displayArray();
    
  ~HPCxx_Array() ;
  
  int length() { return len; }

  int getType() { return type; }

  void setRelease() { rel = 1; }
  
  void setUnrelease() { rel = 0; }

  T* getValue() { return value; }
 
  T& operator[](int index) { return value[index]; }

  const T& operator[](int index) const { return value[index]; }

friend void hpcxx_pack(HPCxx_Buffer &buffer, HPCxx_Array<T,n> *r, int count);
friend void hpcxx_unpack(HPCxx_Buffer &buffer, HPCxx_Array<T,n> *r, int count);

};

template<class T, int n>
void hpcxx_pack(HPCxx_Buffer &buffer, HPCxx_Array<T, n> *r, int count);
template<class T, int n>
void hpcxx_unpack(HPCxx_Buffer &buffer, HPCxx_Array<T, n> *r, int count);

#define HPCxx_Array1 HPCxx_Array

#endif // __HPCXX_ARRAYS_H_
