// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: HPCxx_CondImpl.C,v 1.1 1999/04/17 01:00:21 kate Exp $

#include <HPCxx_CondImpl.h>
#include <iostream.h>

HPCxx_CondImpl::HPCxx_CondImpl()
{
  _signal = 0;
}

HPCxx_CondImpl::HPCxx_CondImpl(const HPCxx_CondImpl& cond) 
: _signal(cond._signal)
{
}

HPCxx_CondImpl::~HPCxx_CondImpl()
{
}

HPCxx_CondImpl& HPCxx_CondImpl::operator=(const HPCxx_CondImpl& cond) {
  if (this == &cond) return *this; // self-assignment
  
  _signal = cond._signal;

  return *this;
}

int HPCxx_CondImpl::wait(HPCxx_MutexImpl &mutex) {
  _signal = 0;
  mutex.unlock();
  while(_signal == 0)
    nexus_poll();
  mutex.lock();
  return(0);
}

int HPCxx_CondImpl::signal()
{
  return(_signal++);
}

int HPCxx_CondImpl::broadcast()
{
  return(_signal++);
}
